libcdr Namespace Reference documentation

libcdr Namespace Reference

## Classes
class | CDRArcToElement
struct | CDRBitmap
struct | CDRBox
class | CDRCloseParagraphOutputElement
class | CDRClosePathElement
class | CDRCloseSpanOutputElement
struct | CDRCMYKColor
class | CDRCollector
struct | CDRColor
class | CDRContentCollector
class | CDRCubicBezierToElement
class | CDRDocument
struct | CDRDummyDeleter
class | CDREndLayerOutputElement
class | CDREndTextObjectOutputElement
struct | CDRFillStyle
struct | CDRFont
struct | CDRGradient
struct | CDRGradientStop
class | CDRGraphicObjectOutputElement
struct | CDRImage
struct | CDRImageFill
class | CDRInsertTextOutputElement
class | CDRInternalStream
struct | CDRLab2Color
struct | CDRLab4Color
struct | CDRLineStyle
class | CDRLineToElement
class | CDRMoveToElement
class | CDROpenParagraphOutputElement
class | CDROpenSpanOutputElement
class | CDROutputElement
class | CDROutputElementList
struct | CDRPage
class | CDRParser
class | CDRParserState
class | CDRPath
class | CDRPathElement
class | CDRPathOutputElement
struct | CDRPattern
struct | CDRPolygon
class | CDRQuadraticBezierToElement
struct | CDRRGBColor
struct | CDRSplineData
class | CDRSplineToElement
class | CDRStartLayerOutputElement
class | CDRStartTextObjectOutputElement
struct | CDRStyle
class | CDRStyleOutputElement
class | CDRStylesCollector
struct | CDRText
struct | CDRTextLine
class | CDRTransform
class | CDRTransforms
class | CMXDocument
struct | CMXImageInfo
struct | CMXLineStyle
struct | CMXOutline
class | CMXParser
struct | CMXParserState
struct | CMXPen
class | CommonParser
class | EncodingException
class | EndOfStreamException
class | GenericException
class | UnknownPrecisionException
struct | WaldoRecordInfo
struct | WaldoRecordType1

## Enumerations
enum | CoordinatePrecision { PRECISION_UNKNOWN = 0 , PRECISION_16BIT , PRECISION_32BIT }

## Functions
template<typename T, typename... Args>
std::unique_ptr< T > | make_unique (Args &&... args)
uint8_t | readU8 (librevenge::RVNGInputStream *input, bool bigEndian=false)
uint16_t | readU16 (librevenge::RVNGInputStream *input, bool bigEndian=false)
uint32_t | readU32 (librevenge::RVNGInputStream *input, bool bigEndian=false)
uint64_t | readU64 (librevenge::RVNGInputStream *input, bool bigEndian=false)
int32_t | readS32 (librevenge::RVNGInputStream *input, bool bigEndian=false)
int16_t | readS16 (librevenge::RVNGInputStream *input, bool bigEndian=false)
double | readDouble (librevenge::RVNGInputStream *input, bool bigEndian=false)
double | readFixedPoint (librevenge::RVNGInputStream *input, bool bigEndian=false)
unsigned long | getLength (librevenge::RVNGInputStream *input)
unsigned long | getRemainingLength (librevenge::RVNGInputStream *input)
int | cdr_round (double d)
void | writeU16 (librevenge::RVNGBinaryData &buffer, const int value)
void | writeU32 (librevenge::RVNGBinaryData &buffer, const int value)
void | appendCharacters (librevenge::RVNGString &text, std::vector< unsigned char > characters, unsigned short charset)
void | appendCharacters (librevenge::RVNGString &text, std::vector< unsigned char > characters)

## Enumeration Type Documentation

## ◆ CoordinatePrecision

enum libcdr::CoordinatePrecision

Enumerator
PRECISION_UNKNOWN |
PRECISION_16BIT |
PRECISION_32BIT |

## Function Documentation

## ◆ appendCharacters() [1/2]

void libcdr::appendCharacters | ( | librevenge::RVNGString & | text,
|  | std::vector< unsigned char > | characters )

## ◆ appendCharacters() [2/2]

void libcdr::appendCharacters | ( | librevenge::RVNGString & | text,
|  | std::vector< unsigned char > | characters,
|  | unsigned short | charset )

Referenced by libcdr::CDRParser::_readX6StyleString(), libcdr::CDRStylesCollector::collectText(), libcdr::CDRParser::readFont(), and libcdr::CDRParser::readUdta().

## ◆ cdr_round()

int libcdr::cdr_round | ( | double | d | ) |

Referenced by libcdr::CDRContentCollector::_flushCurrentPath(), and libcdr::CDRParserState::_getRGBColor().

## ◆ getLength()

unsigned long libcdr::getLength | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by getRemainingLength(), libcdr::CDRParser::readLoda(), libcdr::CDRParser::readStyd(), and libcdr::CDRParser::readTrfd().

## ◆ getRemainingLength()

unsigned long libcdr::getRemainingLength | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libcdr::CDRParser::_readX6StyleString(), libcdr::CMXParser::parseImage(), libcdr::CMXParser::parseRecord(), libcdr::CDRParser::readArrw(), libcdr::CDRParser::readBitmap(), libcdr::CMXParser::readDisp(), libcdr::CMXParser::readFill(), libcdr::CMXParser::readIxef(), libcdr::CMXParser::readIxmr(), libcdr::CMXParser::readIxpg(), libcdr::CMXParser::readIxtl(), libcdr::CDRParser::readLineAndCurve(), libcdr::CDRParser::readOutl(), libcdr::CDRParser::readPath(), libcdr::CMXParser::readPolyCurve(), libcdr::CDRParser::readPolygonCoords(), libcdr::CDRParser::readPpdt(), libcdr::CMXParser::readRclr(), libcdr::CMXParser::readRdot(), libcdr::CommonParser::readRImage(), libcdr::CMXParser::readRotl(), libcdr::CMXParser::readRott(), libcdr::CMXParser::readRpen(), libcdr::CDRParser::readStlt(), libcdr::CMXParser::readString(), libcdr::CDRParser::readTxsm(), libcdr::CDRParser::readTxsm16(), libcdr::CDRParser::readTxsm5(), and libcdr::CDRParser::readTxsm6().

## ◆ make_unique()

template<typename T, typename... Args>

std::unique_ptr< T > libcdr::make_unique | ( | Args &&... | args | ) |

Referenced by libcdr::CDRPath::appendArcTo(), libcdr::CDRPath::appendClosePath(), libcdr::CDRPath::appendCubicBezierTo(), libcdr::CDRPath::appendLineTo(), libcdr::CDRPath::appendMoveTo(), libcdr::CDRPath::appendQuadraticBezierTo(), libcdr::CDRPath::appendSplineTo(), libcdr::CDRArcToElement::clone(), libcdr::CDRClosePathElement::clone(), libcdr::CDRCubicBezierToElement::clone(), libcdr::CDRLineToElement::clone(), libcdr::CDRMoveToElement::clone(), libcdr::CDRPath::clone(), libcdr::CDRQuadraticBezierToElement::clone(), and libcdr::CDRSplineToElement::clone().

## ◆ readDouble()

double libcdr::readDouble | ( | librevenge::RVNGInputStream * | input,
|  | bool | bigEndian = false )

Referenced by libcdr::CMXParser::readCMXHeader(), libcdr::CDRParser::readFtil(), libcdr::CMXParser::readMatrix(), libcdr::CDRParser::readPolygonTransform(), libcdr::CDRParser::readRectangle(), libcdr::CDRParser::readRectCoord(), and libcdr::CDRParser::readTrfd().

## ◆ readFixedPoint()

double libcdr::readFixedPoint | ( | librevenge::RVNGInputStream * | input,
|  | bool | bigEndian = false )

Referenced by libcdr::CDRParser::parseWaldo(), libcdr::CDRParser::readTrfd(), and libcdr::CDRParser::readWaldoTrfd().

## ◆ readS16()

int16_t libcdr::readS16 | ( | librevenge::RVNGInputStream * | input,
|  | bool | bigEndian = false )

Referenced by libcdr::CommonParser::readAngle(), libcdr::CMXParser::readCommands(), libcdr::CommonParser::readCoordinate(), libcdr::CDRParser::readFild(), libcdr::CMXParser::readFill(), libcdr::CommonParser::readInteger(), and libcdr::CDRParser::readWaldoFill().

## ◆ readS32()

int32_t libcdr::readS32 | ( | librevenge::RVNGInputStream * | input,
|  | bool | bigEndian = false )

Referenced by libcdr::CommonParser::readAngle(), libcdr::CMXParser::readCommands(), libcdr::CommonParser::readCoordinate(), libcdr::CDRParser::readFild(), libcdr::CMXParser::readFill(), libcdr::CommonParser::readInteger(), libcdr::CDRParser::readTrfd(), and libcdr::CDRParser::readWaldoTrfd().

## ◆ readU16()

uint16_t libcdr::readU16 | ( | librevenge::RVNGInputStream * | input,
|  | bool | bigEndian = false )

Referenced by libcdr::CDRParser::gatherWaldoInformation(), libcdr::CDRParser::parseRecord(), libcdr::CDRParser::parseWaldo(), libcdr::CDRParser::readArrw(), libcdr::CMXParser::readBeginGroup(), libcdr::CMXParser::readBeginProcedure(), libcdr::CDRParser::readBitmap(), libcdr::CommonParser::readBmpPattern(), libcdr::CMXParser::readCMXHeader(), libcdr::CDRParser::readColor(), libcdr::CMXParser::readColor(), libcdr::CMXParser::readDrawImage(), libcdr::CDRParser::readFild(), libcdr::CMXParser::readFill(), libcdr::CDRParser::readFont(), libcdr::CMXParser::readInfo(), libcdr::CMXParser::readIxef(), libcdr::CMXParser::readIxmr(), libcdr::CMXParser::readIxpc(), libcdr::CMXParser::readIxpg(), libcdr::CMXParser::readIxtl(), libcdr::CMXParser::readLens(), libcdr::CDRParser::readLineAndCurve(), libcdr::CMXParser::readMatrix(), libcdr::CDRParser::readOpacity(), libcdr::CDRParser::readOutl(), libcdr::CDRParser::readPath(), libcdr::CMXParser::readPolyCurve(), libcdr::CDRParser::readPolygonCoords(), libcdr::CDRParser::readPpdt(), libcdr::CMXParser::readRclr(), libcdr::CMXParser::readRdot(), libcdr::CMXParser::readRenderingAttributes(), libcdr::CommonParser::readRImage(), libcdr::CMXParser::readRotl(), libcdr::CMXParser::readRott(), libcdr::CMXParser::readRpen(), readS16(), libcdr::CDRParser::readStlt(), libcdr::CMXParser::readString(), libcdr::CDRParser::readStyd(), libcdr::CDRParser::readTrfd(), libcdr::CDRParser::readTxsm(), libcdr::CDRParser::readTxsm5(), libcdr::CDRParser::readTxsm6(), libcdr::CDRParser::readUdta(), libcdr::CommonParser::readUnsigned(), libcdr::CommonParser::readUnsignedShort(), libcdr::CDRParser::readVersion(), libcdr::CDRParser::readWaldoBmpf(), libcdr::CDRParser::readWaldoFill(), libcdr::CDRParser::readWaldoLoda(), and libcdr::CDRParser::readWaldoOutl().

## ◆ readU32()

uint32_t libcdr::readU32 | ( | librevenge::RVNGInputStream * | input,
|  | bool | bigEndian = false )

Referenced by libcdr::CDRParser::_redirectX6Chunk(), libcdr::CDRParser::gatherWaldoInformation(), libcdr::CMXDocument::isSupported(), libcdr::CMXParser::parseImage(), libcdr::CDRParser::parseRecord(), libcdr::CMXParser::parseRecord(), libcdr::CDRParser::parseWaldo(), libcdr::CDRParser::readArrw(), libcdr::CMXParser::readBeginGroup(), libcdr::CMXParser::readBeginPage(), libcdr::CMXParser::readBeginProcedure(), libcdr::CDRParser::readBmp(), libcdr::CDRParser::readBmpf(), libcdr::CommonParser::readBmpPattern(), libcdr::CMXParser::readCMXHeader(), libcdr::CDRParser::readColor(), libcdr::CMXParser::readData(), libcdr::CDRParser::readDisp(), libcdr::CMXParser::readDisp(), libcdr::CDRParser::readFild(), libcdr::CMXParser::readFill(), readFixedPoint(), libcdr::CDRParser::readFlags(), libcdr::CMXParser::readInfo(), libcdr::CMXParser::readIxef(), libcdr::CMXParser::readIxmr(), libcdr::CMXParser::readIxpc(), libcdr::CMXParser::readIxpg(), libcdr::CMXParser::readIxtl(), libcdr::CMXParser::readJumpAbsolute(), libcdr::CDRParser::readLoda(), libcdr::CDRParser::readOutl(), libcdr::CMXParser::readPage(), libcdr::CDRParser::readPolygonTransform(), libcdr::CDRParser::readPpdt(), libcdr::CMXParser::readProc(), libcdr::CMXParser::readRclr(), libcdr::CMXParser::readRdot(), libcdr::CommonParser::readRImage(), libcdr::CMXParser::readRotl(), libcdr::CMXParser::readRott(), libcdr::CMXParser::readRpen(), readS32(), libcdr::CDRParser::readStlt(), libcdr::CDRParser::readStyd(), libcdr::CDRParser::readTrfd(), libcdr::CDRParser::readTxsm(), libcdr::CDRParser::readTxsm16(), libcdr::CDRParser::readTxsm5(), libcdr::CDRParser::readTxsm6(), libcdr::CDRParser::readUidr(), libcdr::CommonParser::readUnsigned(), libcdr::CDRParser::readWaldoBmpf(), libcdr::CDRParser::readWaldoFill(), libcdr::CDRParser::readWaldoOutl(), and libcdr::CDRParser::readWaldoRecord().

## ◆ readU64()

uint64_t libcdr::readU64 | ( | librevenge::RVNGInputStream * | input,
|  | bool | bigEndian = false )

Referenced by readDouble(), libcdr::CDRParser::readTxsm(), and libcdr::CDRParser::readTxsm16().

## ◆ readU8()

uint8_t libcdr::readU8 | ( | librevenge::RVNGInputStream * | input,
|  | bool | bigEndian = false )

Referenced by libcdr::CDRParser::gatherWaldoInformation(), getLength(), libcdr::CMXDocument::isSupported(), libcdr::CDRDocument::parse(), libcdr::CMXParser::parseImage(), libcdr::CDRParser::parseRecord(), libcdr::CMXParser::parseRecord(), libcdr::CDRParser::parseWaldo(), libcdr::CDRParser::readArrw(), libcdr::CMXParser::readBeginGroup(), libcdr::CMXParser::readBeginPage(), libcdr::CMXParser::readBeginProcedure(), libcdr::CDRParser::readBitmap(), libcdr::CDRParser::readBmp(), libcdr::CMXParser::readCMXHeader(), libcdr::CDRParser::readColor(), libcdr::CMXParser::readColor(), libcdr::CMXParser::readData(), libcdr::CDRParser::readDisp(), libcdr::CMXParser::readDisp(), libcdr::CMXParser::readDrawImage(), libcdr::CMXParser::readEllipse(), libcdr::CDRParser::readFild(), libcdr::CMXParser::readFill(), libcdr::CDRParser::readFont(), libcdr::CMXParser::readInfo(), libcdr::CMXParser::readJumpAbsolute(), libcdr::CMXParser::readLens(), libcdr::CDRParser::readLineAndCurve(), libcdr::CDRParser::readPath(), libcdr::CMXParser::readPolyCurve(), libcdr::CDRParser::readPolygonCoords(), libcdr::CMXParser::readRclr(), libcdr::CMXParser::readRdot(), libcdr::CDRParser::readRectangle(), libcdr::CMXParser::readRectangle(), libcdr::CMXParser::readRenderingAttributes(), libcdr::CommonParser::readRImage(), libcdr::CMXParser::readRotl(), libcdr::CMXParser::readRott(), libcdr::CMXParser::readRpen(), libcdr::CMXParser::readString(), libcdr::CDRParser::readTxsm(), libcdr::CDRParser::readTxsm16(), libcdr::CDRParser::readTxsm5(), libcdr::CDRParser::readTxsm6(), libcdr::CommonParser::readUnsignedShort(), libcdr::CDRParser::readWaldoBmp(), libcdr::CDRParser::readWaldoFill(), libcdr::CDRParser::readWaldoLoda(), and libcdr::CDRParser::readWaldoOutl().

## ◆ writeU16()

void libcdr::writeU16 | ( | librevenge::RVNGBinaryData & | buffer,
|  | const int | value )

Referenced by libcdr::CDRContentCollector::_generateBitmapFromPattern(), and libcdr::CDRStylesCollector::collectBmp().

## ◆ writeU32()

void libcdr::writeU32 | ( | librevenge::RVNGBinaryData & | buffer,
|  | const int | value )

Referenced by libcdr::CDRContentCollector::_generateBitmapFromPattern(), and libcdr::CDRStylesCollector::collectBmp().